image: python:3.7

before_script:
  - pip install pylint
  - pip install coverage

stages:
  - staticna_analiza
  - unit_testi
  - porocilo_pokritosti

static_analysis: 
  stage: staticna_analiza
  script: 
    - pylint myarray/basearray.py --errors-only

testi_izpisa:
  stage: unit_testi
  script:
    - coverage run -p -m unittest tests.myarray.test_array.TestArray.test_print_positive_int
    - coverage run -p -m unittest tests.myarray.test_array.TestArray.test_print_3d_int
    - coverage run -p -m unittest tests.myarray.test_array.TestArray.test_print_3d_float
    - coverage run -p -m unittest tests.myarray.test_array.TestArray.test_print_negative_int
    - coverage run -p -m unittest tests.myarray.test_array.TestArray.test_print_positive_float
    - coverage run -p -m unittest tests.myarray.test_array.TestArray.test_print_negative_float
  artifacts:
    paths: 
      - .coverage.*
    expire_in: 1 day

testi_sortiranja:
  stage: unit_testi
  script:
    - coverage run -p -m unittest tests.myarray.test_array.TestArray.test_merge_sort_1d
    - coverage run -p -m unittest tests.myarray.test_array.TestArray.test_merge_sort_2d_line
    - coverage run -p -m unittest tests.myarray.test_array.TestArray.test_merge_sort_2d_collumn
    - coverage run -p -m unittest tests.myarray.test_array.TestArray.test_merge_sort_1d_float
    - coverage run -p -m unittest tests.myarray.test_array.TestArray.test_merge_sort_2d_line_float
    - coverage run -p -m unittest tests.myarray.test_array.TestArray.test_merge_sort_2d_collumn_float
  artifacts:
    paths: 
      - .coverage.*
    expire_in: 1 day

testi_iskanja:
  stage: unit_testi
  script:
    - coverage run -p -m unittest tests.myarray.test_array.TestArray.test_find_in_ar
    - coverage run -p -m unittest tests.myarray.test_array.TestArray.test_find_in_ar_float
    - coverage run -p -m unittest tests.myarray.test_array.TestArray.test_find_in_ar_2d
    - coverage run -p -m unittest tests.myarray.test_array.TestArray.test_find_in_ar_2d_float
    - coverage run -p -m unittest tests.myarray.test_array.TestArray.test_find_in_ar_3d
    - coverage run -p -m unittest tests.myarray.test_array.TestArray.test_find_in_ar_3d_float
  artifacts:
    paths: 
      - .coverage.*
    expire_in: 1 day

matematicne_funkcije:
  stage: unit_testi
  script:
    - coverage run -p -m unittest tests.myarray.test_array.TestArray.test_sum_ar_arar
    - coverage run -p -m unittest tests.myarray.test_array.TestArray.test_sum_ar_arint
    - coverage run -p -m unittest tests.myarray.test_array.TestArray.test_sum_ar_arar_float
    - coverage run -p -m unittest tests.myarray.test_array.TestArray.test_dif_ar_arar
    - coverage run -p -m unittest tests.myarray.test_array.TestArray.test_dif_ar_arint
    - coverage run -p -m unittest tests.myarray.test_array.TestArray.test_dif_ar_arar_float
    - coverage run -p -m unittest tests.myarray.test_array.TestArray.test_div_ar_arar
    - coverage run -p -m unittest tests.myarray.test_array.TestArray.test_div_ar_arfloat
    - coverage run -p -m unittest tests.myarray.test_array.TestArray.test_mult_ar_arar
    - coverage run -p -m unittest tests.myarray.test_array.TestArray.test_mult_ar_arfloat
    - coverage run -p -m unittest tests.myarray.test_array.TestArray.test_log_ar_arar
    - coverage run -p -m unittest tests.myarray.test_array.TestArray.test_log_ar_arfloat
    - coverage run -p -m unittest tests.myarray.test_array.TestArray.test_pow_ar_arar
    - coverage run -p -m unittest tests.myarray.test_array.TestArray.test_pow_ar_arfloat
    - coverage run -p -m unittest tests.myarray.test_array.TestArray.test_matix_mult
  artifacts:
    paths: 
      - .coverage.*
    expire_in: 1 day

coverage:
  stage: porocilo_pokritosti
  script: 
    - coverage combine
    - coverage report
    - coverage html
  artifacts:
    paths:
      - htmlcov/
    expire_in: 1 week
